import{s as Qe,n as We,o as Re}from"../chunks/scheduler.f6b352c8.js";import{S as je,i as Ie,g as o,s as a,r as l,A as Ee,h as r,f as n,c as s,j as Me,u as p,x as R,k as He,y as De,a as i,v as m,d as c,t as f,w as u}from"../chunks/index.7f38e934.js";import{Q as j}from"../chunks/Question.4fa564ba.js";import{H as I}from"../chunks/Heading.333929c4.js";import{E as ze}from"../chunks/EditOnGithub.c3245a01.js";function Ne(ve){let h,z,E,N,S,F,g,O,x,ke="Which of the following best describes an AI Agent?",U,$,B,G,J,d,K,y,Le="Why does an Agent need to plan before taking an action?",V,w,X,Y,Z,A,ee,b,Te="Why are tools essential for an Agent?",te,v,ne,ie,ae,k,se,L,Ce="What is the key difference between Actions and Tools?",oe,T,re,le,pe,C,me,q,qe="How do LLMs contribute to an Agent’s functionality?",ce,_,fe,ue,he,P,ge,M,_e="Which real-world example best illustrates an AI Agent at work?",xe,H,$e,de,ye,Q,Pe="Congrats on finishing this Quiz 🥳! If you need to review any elements, take the time to revisit the chapter to reinforce your knowledge before diving deeper into the “Agent’s brain”: LLMs.",we,W,Ae,D,be;return g=new I({props:{title:"Q1: What is an Agent?",local:"q1-what-is-an-agent",headingTag:"h3"}}),$=new j({props:{choices:[{text:"A system that solely processes static text, without any inherent mechanism to interact dynamically with its surroundings or execute meaningful actions.",explain:"An Agent must be able to take an action and interact with its environment."},{text:"An AI model that can reason, plan, and use tools to interact with its environment to achieve a specific goal.",explain:"This definition captures the essential characteristics of an Agent.",correct:!0},{text:"A conversational agent restricted to answering queries, lacking the ability to perform any actions or interact with external systems.",explain:"A chatbot like this lacks the ability to take actions, making it different from an Agent."},{text:"An online repository of information that offers static content without the capability to execute tasks or interact actively with users.",explain:"An Agent actively interacts with its environment rather than just providing static information."}]}}),d=new I({props:{title:"Q2: What is the Role of Planning in an Agent?",local:"q2-what-is-the-role-of-planning-in-an-agent",headingTag:"h3"}}),w=new j({props:{choices:[{text:"To primarily store or recall past interactions, rather than mapping out a sequence of future actions.",explain:"Planning is about determining future actions, not storing past interactions."},{text:"To decide on the sequence of actions and select appropriate tools needed to fulfill the user’s request.",explain:"Planning helps the Agent determine the best steps and tools to complete a task.",correct:!0},{text:"To execute a sequence of arbitrary and uncoordinated actions that lack any defined strategy or intentional objective.",explain:"Planning ensures the Agent's actions are intentional and not random."},{text:"To merely convert or translate text, bypassing any process of formulating a deliberate sequence of actions or employing strategic reasoning.",explain:"Planning is about structuring actions, not just converting text."}]}}),A=new I({props:{title:"Q3: How Do Tools Enhance an Agent’s Capabilities?",local:"q3-how-do-tools-enhance-an-agents-capabilities",headingTag:"h3"}}),v=new j({props:{choices:[{text:"Tools serve no real purpose and do not contribute to the Agent’s ability to perform actions beyond basic text generation.",explain:"Tools expand an Agent's capabilities by allowing it to perform actions beyond text generation."},{text:"Tools provide the Agent with the ability to execute actions a text-generation model cannot perform natively, such as making coffee or generating images.",explain:"Tools enable Agents to interact with the real world and complete tasks.",correct:!0},{text:"Tools are solely designed for memory storage, lacking any capacity to facilitate the execution of tasks or enhance interactive performance.",explain:"Tools are primarily for performing actions, not just for storing data."},{text:"Tools severely restrict the Agent exclusively to generating text, thereby preventing it from engaging in a broader range of interactive actions.",explain:"On the contrary, tools allow Agents to go beyond text-based responses."}]}}),k=new I({props:{title:"Q4: How Do Actions Differ from Tools?",local:"q4-how-do-actions-differ-from-tools",headingTag:"h3"}}),T=new j({props:{choices:[{text:"Actions are the steps the Agent takes, while Tools are external resources the Agent can use to perform those actions.",explain:"Actions are higher-level objectives, while Tools are specific functions the Agent can call upon.",correct:!0},{text:"Actions and Tools are entirely identical components that can be used interchangeably, with no clear differences between them.",explain:"No, Actions are goals or tasks, while Tools are specific utilities the Agent uses to achieve them."},{text:"Tools are considered broad utilities available for various functions, whereas Actions are mistakenly thought to be restricted only to physical interactions.",explain:"Not necessarily. Actions can involve both digital and physical tasks."},{text:"Actions inherently require the use of LLMs to be determined and executed, whereas Tools are designed to function autonomously without such dependencies.",explain:"While LLMs help decide Actions, Actions themselves are not dependent on LLMs."}]}}),C=new I({props:{title:"Q5: What Role Do Large Language Models (LLMs) Play in Agents?",local:"q5-what-role-do-large-language-models-llms-play-in-agents",headingTag:"h3"}}),_=new j({props:{choices:[{text:"LLMs function merely as passive repositories that store information, lacking any capability to actively process input or produce dynamic responses.",explain:"LLMs actively process text input and generate responses, rather than just storing information."},{text:"LLMs serve as the reasoning 'brain' of the Agent, processing text inputs to understand instructions and plan actions.",explain:"LLMs enable the Agent to interpret, plan, and decide on the next steps.",correct:!0},{text:"LLMs are erroneously believed to be used solely for image processing, when in fact their primary function is to process and generate text.",explain:"LLMs primarily work with text, although they can sometimes interact with multimodal inputs."},{text:"LLMs are considered completely irrelevant to the operation of AI Agents, implying that they are entirely superfluous in any practical application.",explain:"LLMs are a core component of modern AI Agents."}]}}),P=new I({props:{title:"Q6: Which of the Following Best Demonstrates an AI Agent?",local:"q6-which-of-the-following-best-demonstrates-an-ai-agent",headingTag:"h3"}}),H=new j({props:{choices:[{text:"A static FAQ page on a website that provides fixed information and lacks any interactive or dynamic response capabilities.",explain:"A static FAQ page does not interact dynamically with users or take actions."},{text:"A virtual assistant like Siri or Alexa that can understand spoken commands, reason through them, and perform tasks like setting reminders or sending messages.",explain:"This example includes reasoning, planning, and interaction with the environment.",correct:!0},{text:"A simple calculator that performs arithmetic operations based on fixed rules, without any capability for reasoning or planning.",explain:"A calculator follows fixed rules without reasoning or planning, so it is not an Agent."},{text:"A video game NPC that operates on a fixed script of responses, without the ability to reason, plan, or use external tools.",explain:"Unless the NPC can reason, plan, and use tools, it does not function as an AI Agent."}]}}),W=new ze({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/quiz1.mdx"}}),{c(){h=o("meta"),z=a(),E=o("p"),N=a(),S=o("hr"),F=a(),l(g.$$.fragment),O=a(),x=o("p"),x.textContent=ke,U=a(),l($.$$.fragment),B=a(),G=o("hr"),J=a(),l(d.$$.fragment),K=a(),y=o("p"),y.textContent=Le,V=a(),l(w.$$.fragment),X=a(),Y=o("hr"),Z=a(),l(A.$$.fragment),ee=a(),b=o("p"),b.textContent=Te,te=a(),l(v.$$.fragment),ne=a(),ie=o("hr"),ae=a(),l(k.$$.fragment),se=a(),L=o("p"),L.textContent=Ce,oe=a(),l(T.$$.fragment),re=a(),le=o("hr"),pe=a(),l(C.$$.fragment),me=a(),q=o("p"),q.textContent=qe,ce=a(),l(_.$$.fragment),fe=a(),ue=o("hr"),he=a(),l(P.$$.fragment),ge=a(),M=o("p"),M.textContent=_e,xe=a(),l(H.$$.fragment),$e=a(),de=o("hr"),ye=a(),Q=o("p"),Q.textContent=Pe,we=a(),l(W.$$.fragment),Ae=a(),D=o("p"),this.h()},l(e){const t=Ee("svelte-u9bgzb",document.head);h=r(t,"META",{name:!0,content:!0}),t.forEach(n),z=s(e),E=r(e,"P",{}),Me(E).forEach(n),N=s(e),S=r(e,"HR",{}),F=s(e),p(g.$$.fragment,e),O=s(e),x=r(e,"P",{"data-svelte-h":!0}),R(x)!=="svelte-1hxwi4j"&&(x.textContent=ke),U=s(e),p($.$$.fragment,e),B=s(e),G=r(e,"HR",{}),J=s(e),p(d.$$.fragment,e),K=s(e),y=r(e,"P",{"data-svelte-h":!0}),R(y)!=="svelte-1eozxc0"&&(y.textContent=Le),V=s(e),p(w.$$.fragment,e),X=s(e),Y=r(e,"HR",{}),Z=s(e),p(A.$$.fragment,e),ee=s(e),b=r(e,"P",{"data-svelte-h":!0}),R(b)!=="svelte-nv9rej"&&(b.textContent=Te),te=s(e),p(v.$$.fragment,e),ne=s(e),ie=r(e,"HR",{}),ae=s(e),p(k.$$.fragment,e),se=s(e),L=r(e,"P",{"data-svelte-h":!0}),R(L)!=="svelte-2s725x"&&(L.textContent=Ce),oe=s(e),p(T.$$.fragment,e),re=s(e),le=r(e,"HR",{}),pe=s(e),p(C.$$.fragment,e),me=s(e),q=r(e,"P",{"data-svelte-h":!0}),R(q)!=="svelte-b9qx0n"&&(q.textContent=qe),ce=s(e),p(_.$$.fragment,e),fe=s(e),ue=r(e,"HR",{}),he=s(e),p(P.$$.fragment,e),ge=s(e),M=r(e,"P",{"data-svelte-h":!0}),R(M)!=="svelte-1wo13wl"&&(M.textContent=_e),xe=s(e),p(H.$$.fragment,e),$e=s(e),de=r(e,"HR",{}),ye=s(e),Q=r(e,"P",{"data-svelte-h":!0}),R(Q)!=="svelte-8rnr29"&&(Q.textContent=Pe),we=s(e),p(W.$$.fragment,e),Ae=s(e),D=r(e,"P",{}),Me(D).forEach(n),this.h()},h(){He(h,"name","hf:doc:metadata"),He(h,"content",Se)},m(e,t){De(document.head,h),i(e,z,t),i(e,E,t),i(e,N,t),i(e,S,t),i(e,F,t),m(g,e,t),i(e,O,t),i(e,x,t),i(e,U,t),m($,e,t),i(e,B,t),i(e,G,t),i(e,J,t),m(d,e,t),i(e,K,t),i(e,y,t),i(e,V,t),m(w,e,t),i(e,X,t),i(e,Y,t),i(e,Z,t),m(A,e,t),i(e,ee,t),i(e,b,t),i(e,te,t),m(v,e,t),i(e,ne,t),i(e,ie,t),i(e,ae,t),m(k,e,t),i(e,se,t),i(e,L,t),i(e,oe,t),m(T,e,t),i(e,re,t),i(e,le,t),i(e,pe,t),m(C,e,t),i(e,me,t),i(e,q,t),i(e,ce,t),m(_,e,t),i(e,fe,t),i(e,ue,t),i(e,he,t),m(P,e,t),i(e,ge,t),i(e,M,t),i(e,xe,t),m(H,e,t),i(e,$e,t),i(e,de,t),i(e,ye,t),i(e,Q,t),i(e,we,t),m(W,e,t),i(e,Ae,t),i(e,D,t),be=!0},p:We,i(e){be||(c(g.$$.fragment,e),c($.$$.fragment,e),c(d.$$.fragment,e),c(w.$$.fragment,e),c(A.$$.fragment,e),c(v.$$.fragment,e),c(k.$$.fragment,e),c(T.$$.fragment,e),c(C.$$.fragment,e),c(_.$$.fragment,e),c(P.$$.fragment,e),c(H.$$.fragment,e),c(W.$$.fragment,e),be=!0)},o(e){f(g.$$.fragment,e),f($.$$.fragment,e),f(d.$$.fragment,e),f(w.$$.fragment,e),f(A.$$.fragment,e),f(v.$$.fragment,e),f(k.$$.fragment,e),f(T.$$.fragment,e),f(C.$$.fragment,e),f(_.$$.fragment,e),f(P.$$.fragment,e),f(H.$$.fragment,e),f(W.$$.fragment,e),be=!1},d(e){e&&(n(z),n(E),n(N),n(S),n(F),n(O),n(x),n(U),n(B),n(G),n(J),n(K),n(y),n(V),n(X),n(Y),n(Z),n(ee),n(b),n(te),n(ne),n(ie),n(ae),n(se),n(L),n(oe),n(re),n(le),n(pe),n(me),n(q),n(ce),n(fe),n(ue),n(he),n(ge),n(M),n(xe),n($e),n(de),n(ye),n(Q),n(we),n(Ae),n(D)),n(h),u(g,e),u($,e),u(d,e),u(w,e),u(A,e),u(v,e),u(k,e),u(T,e),u(C,e),u(_,e),u(P,e),u(H,e),u(W,e)}}}const Se='{"title":"Q1: What is an Agent?","local":"q1-what-is-an-agent","sections":[],"depth":3}';function Fe(ve){return Re(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ke extends je{constructor(h){super(),Ie(this,h,Fe,Ne,Qe,{})}}export{Ke as component};
