import{s as je,f as Ie,n as Ee,o as ze}from"../chunks/scheduler.f6b352c8.js";import{S as Ge,i as Oe,g as a,s as l,r as j,A as Be,h as r,f as n,c as i,j as Re,u as I,x as s,k as E,y as Se,a as o,v as z,d as G,t as O,w as B}from"../chunks/index.7f38e934.js";import{H as ce}from"../chunks/Heading.333929c4.js";import{E as De}from"../chunks/EditOnGithub.c3245a01.js";function Ue(de){let u,S,F,D,m,U,f,he="We’re now ready to fine-tune our first model for function-calling 🔥.",W,p,Y,c,be="<p>Answer: We need <strong>data</strong></p>",N,d,we="A model training process can be divided into 3 steps:",K,h,ve='<li><p><strong>The model is pre-trained on a large quantity of data</strong>. The output of that step is a <strong>pre-trained model</strong>. For instance, <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a>. It’s a base model and only knows how <strong>to predict the next token without strong instruction following capabilities</strong>.</p></li> <li><p>To be useful in a chat context, the model then needs to be <strong>fine-tuned</strong> to follow instructions. In this step, it can be trained by model creators, the open-source community, you, or anyone. For instance, <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> is an instruction-tuned model by the Google Team behind the Gemma project.</p></li> <li><p>The model can then be <strong>aligned</strong> to the creator’s preferences. For instance, a customer service chat model that must never be impolite to customers.</p></li>',Q,b,Le="Usually a complete product like Gemini or Mistral <strong>will go through all 3 steps</strong>, whereas the models you can find on Hugging Face have completed one or more steps of this training.",J,w,Te='In this tutorial, we will build a function-calling model based on <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a>. We choose the fine-tuned model <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> instead of the base model <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a> because the fine-tuned model has been improved for our use-case.',V,v,$e="Starting from the pre-trained model <strong>would require more training in order to learn instruction following, chat AND function-calling</strong>.",X,L,_e="By starting from the instruction-tuned model, <strong>we minimize the amount of information that our model needs to learn</strong>.",Z,T,ee,$,ye="LoRA is a popular and lightweight training technique that significantly <strong>reduces the number of trainable parameters</strong>.",te,_,Me="It works by <strong>inserting a smaller number of new weights as an adapter into the model to train</strong>. This makes training with LoRA much faster, memory-efficient, and produces smaller model weights (a few hundred MBs), which are easier to store and share.",ne,g,xe,oe,y,Ce="LoRA works by adding pairs of rank decomposition matrices to Transformer layers, typically focusing on linear layers. During training, we will “freeze” the rest of the model and will only update the weights of those newly added adapters.",le,M,He="By doing so, the number of <strong>parameters</strong> that we need to train drops considerably as we only need to update the adapter’s weights.",ie,x,ke="During inference, the input is passed into the adapter and the base model, or these adapter weights can be merged with the base model, resulting in no additional latency overhead.",ae,C,Pe="LoRA is particularly useful for adapting <strong>large</strong> language models to specific tasks or domains while keeping resource requirements manageable. This helps reduce the memory <strong>required</strong> to train a model.",re,H,Ae='If you want to learn more about how LoRA works, you should check out this <a href="https://huggingface.co/learn/nlp-course/chapter11/4?fw=pt" rel="nofollow">tutorial</a>.',se,k,ue,P,qe='You can access the tutorial notebook 👉 <a href="https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow">here</a>.',ge,A,Fe='Then, click on <a href="https://colab.research.google.com/#fileId=https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a> to be able to run it in a Colab Notebook.',me,q,fe,R,pe;return m=new ce({props:{title:"Let’s Fine-Tune Your Model for Function-Calling",local:"lets-fine-tune-your-model-for-function-calling",headingTag:"h1"}}),p=new ce({props:{title:"How do we train our model for function-calling?",local:"how-do-we-train-our-model-for-function-calling",headingTag:"h2"}}),T=new ce({props:{title:"LoRA (Low-Rank Adaptation of Large Language Models)",local:"lora-low-rank-adaptation-of-large-language-models",headingTag:"h2"}}),k=new ce({props:{title:"Fine-Tuning a Model for Function-Calling",local:"fine-tuning-a-model-for-function-calling",headingTag:"h2"}}),q=new De({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/bonus-unit1/fine-tuning.mdx"}}),{c(){u=a("meta"),S=l(),F=a("p"),D=l(),j(m.$$.fragment),U=l(),f=a("p"),f.textContent=he,W=l(),j(p.$$.fragment),Y=l(),c=a("blockquote"),c.innerHTML=be,N=l(),d=a("p"),d.textContent=we,K=l(),h=a("ol"),h.innerHTML=ve,Q=l(),b=a("p"),b.innerHTML=Le,J=l(),w=a("p"),w.innerHTML=Te,V=l(),v=a("p"),v.innerHTML=$e,X=l(),L=a("p"),L.innerHTML=_e,Z=l(),j(T.$$.fragment),ee=l(),$=a("p"),$.innerHTML=ye,te=l(),_=a("p"),_.innerHTML=Me,ne=l(),g=a("img"),oe=l(),y=a("p"),y.textContent=Ce,le=l(),M=a("p"),M.innerHTML=He,ie=l(),x=a("p"),x.textContent=ke,ae=l(),C=a("p"),C.innerHTML=Pe,re=l(),H=a("p"),H.innerHTML=Ae,se=l(),j(k.$$.fragment),ue=l(),P=a("p"),P.innerHTML=qe,ge=l(),A=a("p"),A.innerHTML=Fe,me=l(),j(q.$$.fragment),fe=l(),R=a("p"),this.h()},l(e){const t=Be("svelte-u9bgzb",document.head);u=r(t,"META",{name:!0,content:!0}),t.forEach(n),S=i(e),F=r(e,"P",{}),Re(F).forEach(n),D=i(e),I(m.$$.fragment,e),U=i(e),f=r(e,"P",{"data-svelte-h":!0}),s(f)!=="svelte-1w2cdk2"&&(f.textContent=he),W=i(e),I(p.$$.fragment,e),Y=i(e),c=r(e,"BLOCKQUOTE",{"data-svelte-h":!0}),s(c)!=="svelte-50lzq8"&&(c.innerHTML=be),N=i(e),d=r(e,"P",{"data-svelte-h":!0}),s(d)!=="svelte-1vy0wop"&&(d.textContent=we),K=i(e),h=r(e,"OL",{"data-svelte-h":!0}),s(h)!=="svelte-e66085"&&(h.innerHTML=ve),Q=i(e),b=r(e,"P",{"data-svelte-h":!0}),s(b)!=="svelte-j516b4"&&(b.innerHTML=Le),J=i(e),w=r(e,"P",{"data-svelte-h":!0}),s(w)!=="svelte-1t69dsv"&&(w.innerHTML=Te),V=i(e),v=r(e,"P",{"data-svelte-h":!0}),s(v)!=="svelte-1lgjfmo"&&(v.innerHTML=$e),X=i(e),L=r(e,"P",{"data-svelte-h":!0}),s(L)!=="svelte-k6fall"&&(L.innerHTML=_e),Z=i(e),I(T.$$.fragment,e),ee=i(e),$=r(e,"P",{"data-svelte-h":!0}),s($)!=="svelte-fzvrcp"&&($.innerHTML=ye),te=i(e),_=r(e,"P",{"data-svelte-h":!0}),s(_)!=="svelte-1d45inf"&&(_.innerHTML=Me),ne=i(e),g=r(e,"IMG",{src:!0,alt:!0,width:!0}),oe=i(e),y=r(e,"P",{"data-svelte-h":!0}),s(y)!=="svelte-nrn060"&&(y.textContent=Ce),le=i(e),M=r(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-18jenha"&&(M.innerHTML=He),ie=i(e),x=r(e,"P",{"data-svelte-h":!0}),s(x)!=="svelte-1qgui5b"&&(x.textContent=ke),ae=i(e),C=r(e,"P",{"data-svelte-h":!0}),s(C)!=="svelte-1ljk72i"&&(C.innerHTML=Pe),re=i(e),H=r(e,"P",{"data-svelte-h":!0}),s(H)!=="svelte-c65jgv"&&(H.innerHTML=Ae),se=i(e),I(k.$$.fragment,e),ue=i(e),P=r(e,"P",{"data-svelte-h":!0}),s(P)!=="svelte-jv048l"&&(P.innerHTML=qe),ge=i(e),A=r(e,"P",{"data-svelte-h":!0}),s(A)!=="svelte-1qxcshv"&&(A.innerHTML=Fe),me=i(e),I(q.$$.fragment,e),fe=i(e),R=r(e,"P",{}),Re(R).forEach(n),this.h()},h(){E(u,"name","hf:doc:metadata"),E(u,"content",We),Ie(g.src,xe="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/blog_multi-lora-serving_LoRA.gif")||E(g,"src",xe),E(g,"alt","LoRA inference"),E(g,"width","50%")},m(e,t){Se(document.head,u),o(e,S,t),o(e,F,t),o(e,D,t),z(m,e,t),o(e,U,t),o(e,f,t),o(e,W,t),z(p,e,t),o(e,Y,t),o(e,c,t),o(e,N,t),o(e,d,t),o(e,K,t),o(e,h,t),o(e,Q,t),o(e,b,t),o(e,J,t),o(e,w,t),o(e,V,t),o(e,v,t),o(e,X,t),o(e,L,t),o(e,Z,t),z(T,e,t),o(e,ee,t),o(e,$,t),o(e,te,t),o(e,_,t),o(e,ne,t),o(e,g,t),o(e,oe,t),o(e,y,t),o(e,le,t),o(e,M,t),o(e,ie,t),o(e,x,t),o(e,ae,t),o(e,C,t),o(e,re,t),o(e,H,t),o(e,se,t),z(k,e,t),o(e,ue,t),o(e,P,t),o(e,ge,t),o(e,A,t),o(e,me,t),z(q,e,t),o(e,fe,t),o(e,R,t),pe=!0},p:Ee,i(e){pe||(G(m.$$.fragment,e),G(p.$$.fragment,e),G(T.$$.fragment,e),G(k.$$.fragment,e),G(q.$$.fragment,e),pe=!0)},o(e){O(m.$$.fragment,e),O(p.$$.fragment,e),O(T.$$.fragment,e),O(k.$$.fragment,e),O(q.$$.fragment,e),pe=!1},d(e){e&&(n(S),n(F),n(D),n(U),n(f),n(W),n(Y),n(c),n(N),n(d),n(K),n(h),n(Q),n(b),n(J),n(w),n(V),n(v),n(X),n(L),n(Z),n(ee),n($),n(te),n(_),n(ne),n(g),n(oe),n(y),n(le),n(M),n(ie),n(x),n(ae),n(C),n(re),n(H),n(se),n(ue),n(P),n(ge),n(A),n(me),n(fe),n(R)),n(u),B(m,e),B(p,e),B(T,e),B(k,e),B(q,e)}}}const We='{"title":"Let’s Fine-Tune Your Model for Function-Calling","local":"lets-fine-tune-your-model-for-function-calling","sections":[{"title":"How do we train our model for function-calling?","local":"how-do-we-train-our-model-for-function-calling","sections":[],"depth":2},{"title":"LoRA (Low-Rank Adaptation of Large Language Models)","local":"lora-low-rank-adaptation-of-large-language-models","sections":[],"depth":2},{"title":"Fine-Tuning a Model for Function-Calling","local":"fine-tuning-a-model-for-function-calling","sections":[],"depth":2}],"depth":1}';function Ye(de){return ze(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ve extends Ge{constructor(u){super(),Oe(this,u,Ye,Ue,je,{})}}export{Ve as component};
