import{s as Ft,f as Gt,n as Bt,o as Nt}from"../chunks/scheduler.f6b352c8.js";import{S as zt,i as Ot,g as h,s as l,r as F,A as jt,h as g,f as e,c as o,j as Et,u as G,x as a,k as B,y as St,a as i,v as N,d as z,t as O,w as j}from"../chunks/index.7f38e934.js";import{H as pt}from"../chunks/Heading.333929c4.js";import{E as Vt}from"../chunks/EditOnGithub.c3245a01.js";function It(ft){let c,S,R,V,s,I,r,dt="Chúng ta đã sẵn sàng để fine-tune (tinh chỉnh) model đầu tiên cho function-calling rồi đây 🔥.",K,u,Q,p,bt="<p>Câu trả lời: Ta cần <strong>data</strong></p>",U,f,vt="Quá trình training model có thể chia thành 3 bước:",D,d,Lt='<li><p><strong>Model được pretrain trên lượng data khổng lồ</strong>. Kết quả của bước này là <strong>pretrained model</strong>. Ví dụ: <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a>. Đây là model nền tảng và chỉ biết <strong>dự đoán token tiếp theo mà không có khả năng tuân theo chỉ dẫn</strong>.</p></li> <li><p>Để hữu ích trong bối cảnh chat, model cần được <strong>fine-tune</strong> để tuân theo hướng dẫn. Ở bước này, quá trình training có thể được thực hiện bởi nhà phát triển model, cộng đồng mã nguồn mở, bạn hay bất kỳ ai. Ví dụ: <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> là model đã được fine-tune để tuân theo chỉ dẫn bởi đội ngũ Google của dự án Gemma.</p></li> <li><p>Model sau đó có thể được <strong>alignment</strong> (cân chỉnh) theo mong muốn của người tạo. Ví dụ: model chat hỗ trợ khách hàng không bao giờ được bất lịch sự.</p></li>',J,b,Tt="Thông thường các sản phẩm hoàn chỉnh như Gemini hay Mistral <strong>sẽ trải qua cả 3 bước</strong>, trong khi các model bạn tìm thấy trên Hugging Face đã hoàn thành một hoặc nhiều bước training.",W,v,$t='Trong hướng dẫn này, chúng ta sẽ xây dựng model function-calling dựa trên <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a>. Ta chọn model đã fine-tune <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> thay vì model nền tảng <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a> vì model đã fine-tune đã được cải thiện cho use-case của ta.',X,L,Mt="Nếu bắt đầu từ pretrained model <strong>sẽ cần training nhiều hơn để học cách tuân theo chỉ dẫn, chat VÀ function-calling</strong>.",Y,T,_t="Bằng cách bắt đầu từ model đã fine-tune để tuân theo chỉ dẫn, <strong>ta giảm thiểu lượng thông tin model cần học</strong>.",Z,$,tt,M,yt="LoRA là kỹ thuật training nhẹ và phổ biến giúp <strong>giảm đáng kể số parameters cần training</strong>.",nt,_,xt="Nó hoạt động bằng cách <strong>chèn một lượng nhỏ weights mới vào model như adapter để training</strong>. Điều này giúp training với LoRA nhanh hơn, tiết kiệm bộ nhớ hơn, và tạo ra weights model nhỏ hơn (vài trăm MB), dễ lưu trữ và chia sẻ.",et,m,Ct,it,y,Ht="LoRA hoạt động bằng cách thêm các cặp ma trận phân tách hạng vào các lớp Transformer, thường tập trung vào các lớp tuyến tính. Trong quá trình training, ta sẽ “đóng băng” phần còn lại của model và chỉ cập nhật weights của các adapter mới này.",lt,x,wt="Nhờ vậy, số <strong>parameters</strong> cần training giảm đáng kể vì ta chỉ cần cập nhật weights của adapter.",ot,C,kt="Trong quá trình inference, đầu vào sẽ đi qua adapter và model nền tảng, hoặc các weights adapter có thể được hợp nhất với model nền tảng mà không gây thêm độ trễ.",ht,H,Pt="LoRA đặc biệt hữu ích để điều chỉnh các mô hình ngôn ngữ <strong>lớn</strong> cho các tác vụ hoặc lĩnh vực cụ thể trong khi vẫn quản lý được yêu cầu tài nguyên. Điều này giúp giảm bộ nhớ <strong>required</strong> để training model.",gt,w,qt='Nếu muốn tìm hiểu thêm về cách hoạt động của LoRA, hãy xem <a href="https://huggingface.co/learn/nlp-course/chapter11/4?fw=pt" rel="nofollow">hướng dẫn này</a>.',at,k,ct,P,At='Bạn có thể truy cập notebook hướng dẫn tại đây 👉 <a href="https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow">đây</a>.',mt,q,Rt='Sau đó, click vào <a href="https://colab.research.google.com/#fileId=https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a> để chạy notebook trên Colab.',st,A,rt,E,ut;return s=new pt({props:{title:"Hãy Fine-Tune Model của Bạn cho Chức năng Gọi Hàm",local:"hãy-fine-tune-model-của-bạn-cho-chức-năng-gọi-hàm",headingTag:"h1"}}),u=new pt({props:{title:"Làm thế nào để training model cho function-calling?",local:"làm-thế-nào-để-training-model-cho-function-calling",headingTag:"h2"}}),$=new pt({props:{title:"LoRA (Low-Rank Adaptation of Large Language Models - Thích ứng Hạng thấp cho Mô hình Ngôn ngữ Lớn)",local:"lora-low-rank-adaptation-of-large-language-models---thích-ứng-hạng-thấp-cho-mô-hình-ngôn-ngữ-lớn",headingTag:"h2"}}),k=new pt({props:{title:"Fine-Tuning (tinh chỉnh) Model cho Function-Calling",local:"fine-tuning-tinh-chỉnh-model-cho-function-calling",headingTag:"h2"}}),A=new Vt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/vi/bonus-unit1/fine-tuning.mdx"}}),{c(){c=h("meta"),S=l(),R=h("p"),V=l(),F(s.$$.fragment),I=l(),r=h("p"),r.textContent=dt,K=l(),F(u.$$.fragment),Q=l(),p=h("blockquote"),p.innerHTML=bt,U=l(),f=h("p"),f.textContent=vt,D=l(),d=h("ol"),d.innerHTML=Lt,J=l(),b=h("p"),b.innerHTML=Tt,W=l(),v=h("p"),v.innerHTML=$t,X=l(),L=h("p"),L.innerHTML=Mt,Y=l(),T=h("p"),T.innerHTML=_t,Z=l(),F($.$$.fragment),tt=l(),M=h("p"),M.innerHTML=yt,nt=l(),_=h("p"),_.innerHTML=xt,et=l(),m=h("img"),it=l(),y=h("p"),y.textContent=Ht,lt=l(),x=h("p"),x.innerHTML=wt,ot=l(),C=h("p"),C.textContent=kt,ht=l(),H=h("p"),H.innerHTML=Pt,gt=l(),w=h("p"),w.innerHTML=qt,at=l(),F(k.$$.fragment),ct=l(),P=h("p"),P.innerHTML=At,mt=l(),q=h("p"),q.innerHTML=Rt,st=l(),F(A.$$.fragment),rt=l(),E=h("p"),this.h()},l(t){const n=jt("svelte-u9bgzb",document.head);c=g(n,"META",{name:!0,content:!0}),n.forEach(e),S=o(t),R=g(t,"P",{}),Et(R).forEach(e),V=o(t),G(s.$$.fragment,t),I=o(t),r=g(t,"P",{"data-svelte-h":!0}),a(r)!=="svelte-iqcx1s"&&(r.textContent=dt),K=o(t),G(u.$$.fragment,t),Q=o(t),p=g(t,"BLOCKQUOTE",{"data-svelte-h":!0}),a(p)!=="svelte-15rq0a8"&&(p.innerHTML=bt),U=o(t),f=g(t,"P",{"data-svelte-h":!0}),a(f)!=="svelte-aowbe7"&&(f.textContent=vt),D=o(t),d=g(t,"OL",{"data-svelte-h":!0}),a(d)!=="svelte-ca7q22"&&(d.innerHTML=Lt),J=o(t),b=g(t,"P",{"data-svelte-h":!0}),a(b)!=="svelte-6abnz6"&&(b.innerHTML=Tt),W=o(t),v=g(t,"P",{"data-svelte-h":!0}),a(v)!=="svelte-11u4m3g"&&(v.innerHTML=$t),X=o(t),L=g(t,"P",{"data-svelte-h":!0}),a(L)!=="svelte-2rjief"&&(L.innerHTML=Mt),Y=o(t),T=g(t,"P",{"data-svelte-h":!0}),a(T)!=="svelte-1llj3sm"&&(T.innerHTML=_t),Z=o(t),G($.$$.fragment,t),tt=o(t),M=g(t,"P",{"data-svelte-h":!0}),a(M)!=="svelte-m8fvhy"&&(M.innerHTML=yt),nt=o(t),_=g(t,"P",{"data-svelte-h":!0}),a(_)!=="svelte-13mteja"&&(_.innerHTML=xt),et=o(t),m=g(t,"IMG",{src:!0,alt:!0,width:!0}),it=o(t),y=g(t,"P",{"data-svelte-h":!0}),a(y)!=="svelte-1fbxmsa"&&(y.textContent=Ht),lt=o(t),x=g(t,"P",{"data-svelte-h":!0}),a(x)!=="svelte-ccc7uy"&&(x.innerHTML=wt),ot=o(t),C=g(t,"P",{"data-svelte-h":!0}),a(C)!=="svelte-1izdtsz"&&(C.textContent=kt),ht=o(t),H=g(t,"P",{"data-svelte-h":!0}),a(H)!=="svelte-1qoifrf"&&(H.innerHTML=Pt),gt=o(t),w=g(t,"P",{"data-svelte-h":!0}),a(w)!=="svelte-1a3xzdk"&&(w.innerHTML=qt),at=o(t),G(k.$$.fragment,t),ct=o(t),P=g(t,"P",{"data-svelte-h":!0}),a(P)!=="svelte-1vegqqg"&&(P.innerHTML=At),mt=o(t),q=g(t,"P",{"data-svelte-h":!0}),a(q)!=="svelte-ywtngx"&&(q.innerHTML=Rt),st=o(t),G(A.$$.fragment,t),rt=o(t),E=g(t,"P",{}),Et(E).forEach(e),this.h()},h(){B(c,"name","hf:doc:metadata"),B(c,"content",Kt),Gt(m.src,Ct="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/blog_multi-lora-serving_LoRA.gif")||B(m,"src",Ct),B(m,"alt","LoRA inference"),B(m,"width","50%")},m(t,n){St(document.head,c),i(t,S,n),i(t,R,n),i(t,V,n),N(s,t,n),i(t,I,n),i(t,r,n),i(t,K,n),N(u,t,n),i(t,Q,n),i(t,p,n),i(t,U,n),i(t,f,n),i(t,D,n),i(t,d,n),i(t,J,n),i(t,b,n),i(t,W,n),i(t,v,n),i(t,X,n),i(t,L,n),i(t,Y,n),i(t,T,n),i(t,Z,n),N($,t,n),i(t,tt,n),i(t,M,n),i(t,nt,n),i(t,_,n),i(t,et,n),i(t,m,n),i(t,it,n),i(t,y,n),i(t,lt,n),i(t,x,n),i(t,ot,n),i(t,C,n),i(t,ht,n),i(t,H,n),i(t,gt,n),i(t,w,n),i(t,at,n),N(k,t,n),i(t,ct,n),i(t,P,n),i(t,mt,n),i(t,q,n),i(t,st,n),N(A,t,n),i(t,rt,n),i(t,E,n),ut=!0},p:Bt,i(t){ut||(z(s.$$.fragment,t),z(u.$$.fragment,t),z($.$$.fragment,t),z(k.$$.fragment,t),z(A.$$.fragment,t),ut=!0)},o(t){O(s.$$.fragment,t),O(u.$$.fragment,t),O($.$$.fragment,t),O(k.$$.fragment,t),O(A.$$.fragment,t),ut=!1},d(t){t&&(e(S),e(R),e(V),e(I),e(r),e(K),e(Q),e(p),e(U),e(f),e(D),e(d),e(J),e(b),e(W),e(v),e(X),e(L),e(Y),e(T),e(Z),e(tt),e(M),e(nt),e(_),e(et),e(m),e(it),e(y),e(lt),e(x),e(ot),e(C),e(ht),e(H),e(gt),e(w),e(at),e(ct),e(P),e(mt),e(q),e(st),e(rt),e(E)),e(c),j(s,t),j(u,t),j($,t),j(k,t),j(A,t)}}}const Kt='{"title":"Hãy Fine-Tune Model của Bạn cho Chức năng Gọi Hàm","local":"hãy-fine-tune-model-của-bạn-cho-chức-năng-gọi-hàm","sections":[{"title":"Làm thế nào để training model cho function-calling?","local":"làm-thế-nào-để-training-model-cho-function-calling","sections":[],"depth":2},{"title":"LoRA (Low-Rank Adaptation of Large Language Models - Thích ứng Hạng thấp cho Mô hình Ngôn ngữ Lớn)","local":"lora-low-rank-adaptation-of-large-language-models---thích-ứng-hạng-thấp-cho-mô-hình-ngôn-ngữ-lớn","sections":[],"depth":2},{"title":"Fine-Tuning (tinh chỉnh) Model cho Function-Calling","local":"fine-tuning-tinh-chỉnh-model-cho-function-calling","sections":[],"depth":2}],"depth":1}';function Qt(ft){return Nt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xt extends zt{constructor(c){super(),Ot(this,c,Qt,It,Ft,{})}}export{Xt as component};
